//---------------------------------------------------------------------
//(16x16Dot)LED Game for AVR  by Takuya Matsubara / NICO Corp. 2006-2008
// http://www.nicotak.com/avr/
//
// Px΍
//
//---------------------------------------------------------------------
#include <avr/io.h>
#include <avr/interrupt.h>
#include "led.h"
#include "sw.h"

#ifndef F_CPU
	#define F_CPU 8000000	// CPUNbNg[Hz]
#endif

	#define INTRCYCLE  100	//荞ݎ[Hz]

	#define T2PRESCALE  1024		// ^C}vXP[l
	#define T2PRESCALER 7		// ^C}vXP[ݒ
	// 1=div1 / 2=div8 / 3=div32 / 4=div64 / 5=div128 / 6=div256 / 7=div1K
	#define T2STA (0x100-((F_CPU/T2PRESCALE)/INTRCYCLE))

void timer_init(void)
{
	//---------------^C}荞
    TCCR2A= 0;       // ^C}[hݒ
    TCCR2B= T2PRESCALER;       // vXP[ݒ 
    TCNT2 = T2STA;        // ^C}̏lݒ   
    TIFR2 |= (1 << TOV2);    // I[o[t[tONA
    TIMSK2 |= (1 << TOIE2);  // ^C}I[o[t[荞݋
}

unsigned char tcnt=0;

//-----------------^C}荞
SIGNAL (SIG_OVERFLOW2)
{
	TCNT2 =T2STA;        // ^C}̏lݒ   

	if(tcnt)
		tcnt--;
}


int dotnum = 0;

void led_testpattern(void)
{
	led_scroll(0,1);

	led_line(0, 15, dotnum, 15, 1);

	dotnum++;
	if(dotnum >= 16) dotnum=0;
}

//---------------------------------------------------------------------
// C
int main(void)
{
	int linenum;


	sw_init(SW_ALL);
	led_init();				// LED
	timer_init();

	sei();
	while(1){
		for( linenum=0; linenum<16 	;linenum++){
			led_testpattern();	//make test pattern

			tcnt = 50;
			while(tcnt){
				led_disp();		// LEDʍXV(new)
			}
		}
		for( linenum=0; linenum<16 	;linenum++){
			led_testpattern();	//make test pattern

			tcnt = 50;
			while(tcnt){
				led_disp_old();		// LEDʍXV(old)
			}
		}
	}
}


